Bug 1392837 - A hard link is lost during rebalance+lookup
Summary: A hard link is lost during rebalance+lookup
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: distribute
Version: rhgs-3.2
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
: RHGS 3.2.0
Assignee: Mohit Agrawal
QA Contact: Prasad Desala
URL:
Whiteboard:
Depends On: 1396048 1399430
Blocks: 1351528 1399432
TreeView+ depends on / blocked
 
Reported: 2016-11-08 10:57 UTC by Prasad Desala
Modified: 2017-04-10 09:36 UTC (History)
8 users (show)

Fixed In Version: glusterfs-3.8.4-6
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1396048 1399430 1399432 (view as bug list)
Environment:
Last Closed: 2017-03-23 06:16:44 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:0486 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.2.0 security, bug fix, and enhancement update 2017-03-23 09:18:45 UTC

Description Prasad Desala 2016-11-08 10:57:35 UTC
Description of problem:
=======================
Hard link fl3275 is lost when performed below steps,

Version-Release number of selected component (if applicable):
3.8.4-3.el7rhgs.x86_64

How reproducible:
=================
1/1

Steps to Reproduce:
===================
1) Create a distributed replicate volume and start it.
2) Fuse mount the volume on multiple clients.
3) Perform below tasks simultaneously from multiple clients,
     a) From client-1, touch -->  for i in {1..20000};do touch f$i;done
     b) From client-2, create hard links for the created files , for i in {1..20000};do ln f$i fl$i;done
     c) From client-3, change the permissions for the created files, for i in {1..20000};do chmod 660 f$i;done
     d) From client-4, do a continuous lookup.
5) While the tasks in step-4 are in progress, add few bricks to the volume and start rebalance.
Wait till step-4 and step-5 completes.
Check the created files and hard links count.

Actual results:
===============
Hard link fl3275 is lost

Expected results:
=================
No data loss should be seen.

Comment 8 Atin Mukherjee 2016-11-21 05:02:18 UTC
upstream mainline patch http://review.gluster.org/15866 posted for review.

Comment 13 Prasad Desala 2017-01-02 06:30:04 UTC
Repeated the steps in the description thrice with glusterfs version 3.8.4-10.el7rhgs.x86_64. I did not see any hardlink loss, all the created hardlinks are available post rebalance.

Moving this BZ to Verified.

Comment 15 errata-xmlrpc 2017-03-23 06:16:44 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0486.html


Note You need to log in before you can comment on or make changes to this bug.